### Code Formatting Guidelines

 - 2 spaces per indentation level, no tabs
 - Use whitespace to make the code more readable
 - No whitespace at the end of a line (trailing whitespace)
 - Try to adhere to a 80 character line length limit
 - No Unicode
 - Spaces after commas

### Naming Conventions

 - Use lower case with underscores for method names, for example,
   `prime_decomposition` instead of `primedecomposition` and
   `basis_matrix` instead of `basismat`. The only exception are method
   names that start with an `is` (predicates). In this case there is
   no underscore between `is` and the word that follows. For example,
   it is `issubgroup` instead of `is_subgroup` and `istorsion_point`
   instead of `is_torsion_point`.
 - Use upper camel case convention for type names
